# - Config to retrieve all components of the ignition-common2 package
#
# This should only be invoked by ignition-common2-config.cmake.
#
# To retrieve this meta-package, use:
# find_package(ignition-common2 COMPONENTS all)
#
# This creates the target ignition-common2::all which will link to all known
# components of ignition-common2, including the core library.
#
# This also creates the variable ignition-common2_ALL_LIBRARIES
#
################################################################################

cmake_minimum_required(VERSION 3.5.1 FATAL_ERROR)

if(ignition-common2_ALL_CONFIG_INCLUDED)
  return()
endif()
set(ignition-common2_ALL_CONFIG_INCLUDED TRUE)

if(NOT ignition-common2-all_FIND_QUIETLY)
  message(STATUS "Looking for all libraries of ignition-common2 -- found version 2.0.0~pre1")
endif()


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was ignition-all-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/x86_64-linux-gnu/cmake/ignition-common2-all" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

# Get access to the find_dependency utility
include(CMakeFindDependencyMacro)

# Find the core library
find_dependency(ignition-common2 2.0.0 EXACT)

# Find the component libraries
find_dependency(ignition-common2-av 2.0.0 EXACT)
find_dependency(ignition-common2-events 2.0.0 EXACT)
find_dependency(ignition-common2-graphics 2.0.0 EXACT)

if(NOT TARGET ignition-common2::ignition-common2-all)
  include("${CMAKE_CURRENT_LIST_DIR}/ignition-common2-all-targets.cmake")

  add_library(ignition-common2::all INTERFACE IMPORTED)
  set_target_properties(ignition-common2::all PROPERTIES
    INTERFACE_LINK_LIBRARIES "ignition-common2::ignition-common2-all")

endif()

# Create the "requested" target if it does not already exist
if(NOT TARGET ignition-common2::requested)
  add_library(ignition-common2::requested INTERFACE IMPORTED)
endif()

# Link the "all" target to the "requested" target
get_target_property(ign_requested_components ignition-common2::requested INTERFACE_LINK_LIBRARIES)
if(NOT ign_requested_components)
  set_target_properties(ignition-common2::requested PROPERTIES
    INTERFACE_LINK_LIBRARIES "ignition-common2::ignition-common2-all")
else()
  set_target_properties(ignition-common2::requested PROPERTIES
    INTERFACE_LINK_LIBRARIES "${ign_requested_components};ignition-common2::ignition-common2-all")
endif()

set(ignition-common2_ALL_LIBRARIES ignition-common2::ignition-common2-all)
